<?php
    if(!defined("IN_MYBB"))
    {
        die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
    } 

    //hooks
    $plugins->add_hook("member_profile_end", "SignatureControlProfile");
    $plugins->add_hook("postbit", "signatureControl");





    function SignatureControl_info()
    {
        return array(
        "name"          => "Signature Control",
        "description"   => "This plugin limits the use of signatures for users.",
        "website"       => "http://www.dev-network.com",
        "author"        => "Tom K.",
        "authorsite"    => "http://community.mybb.com/user-22017.html",
        "compatibility" => "16*",
        "version"       => "1.1_03",
        "GUID"             => "1d15ad41e3d18c6bd1bae1940585adaf",
        );
    }

    //All the activation processes go here
    function SignatureControl_activate()
    {

        global $db;


        $group = array(
        "gid"            => "12376",
        "title"          => "Signature Control",
        "name"           => "signaturecontrol",
        "description"    => "Settings for the Signature Control Plugin",
        "disporder"      => "1",
        "isdefault"      => "no",
        );

        $db->insert_query("settinggroups", $group);
        $gid = $db->insert_id(); 


        $SignatureControl_onSetting = array(
        "sid"            => "1024",
        "name"           => "signaturecontrol_onsetting",
        "title"          => "Enabled?",
        "description"    => "Turn the Signature Control Plugin On and Off",
        "optionscode"    => "yesno",
        "value"          => 'yes',
        "disporder"      => '1',
        "gid"            => '12376',
        );

        $db->insert_query("settings", $SignatureControl_onSetting);


        $SignatureControl_PostsCountRequired = array(
        "sid"            => "1025",
        "name"           => "signaturecontrol_postcount",
        "title"          => "Required postcount",
        "description"    => "The minimum amount of posts needed to display the signature.",
        "optionscode"    => "text",
        "value"          => '10',
        "disporder"      => '2',
        "gid"            => '12376',
        );

        $db->insert_query("settings", $SignatureControl_PostsCountRequired);

        $SignatureControl_ExemptGroups = array(
        "sid"            => "1026",
        "name"           => "signaturecontrol_exemptgroups",
        "title"          => "Exempt Usergroups",
        "description"    => "Place usergroups (comma separated) to allow them to display signatures regardless of postcount.",
        "optionscode"    => "text",
        "value"          => '4',
        "disporder"      => '3',
        "gid"            => '12376',
        );

        $db->insert_query("settings", $SignatureControl_ExemptGroups);
        rebuildsettings();

        require MYBB_ROOT.'/inc/adminfunctions_templates.php';
        find_replace_templatesets("member_profile", '#'.preg_quote('{$signature}').'#' , '{$SignatureControlProfile}');



    }

    //All deactivation processes go here
    function SignatureControl_deactivate()
    {

        global $db;
        //remove settings
        $db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='signaturecontrol_onsetting'");
        $db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='signaturecontrol_postcount'");
        $db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='signaturecontrol_exemptgroups'");
        $db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='signaturecontrol'");
        rebuildsettings();

        require MYBB_ROOT.'/inc/adminfunctions_templates.php';

        find_replace_templatesets("member_profile", '#'.preg_quote('{$SignatureControlProfile').'#s' , '{$signature}',0); 



    } 

    function SignatureControl($post)
    {           
        global $mybb;
        $gidlist  = "0," . $mybb->settings['signaturecontrol_exemptgroups'] . ",";
        $groups = explode(",", $gidlist);

        if ($mybb->settings['signaturecontrol_onsetting'] == 1 OR $mybb->settings['signaturecontrol_onsetting'] == "yes")
        {
            if (in_array($post['usergroup'],$groups) == true) {
                $post['signature'] = $post['signature'];
            }
            else {
                if ($post['postnum'] >= $mybb->settings['signaturecontrol_postcount'])
                {
                    $post['signature'] = $post['signature'];
                }
                else {
                    $post['signature'] = "";
                }
            }
        }
        else {
            $post['signature'] = $post['signature'];
            echo "disabled";
        }

    }

    function SignatureControlProfile()
    {           
        require_once "global.php";
        global $mybb, $memprofile, $theme, $lang, $SignatureControlProfile;
        //print_r($memprofile);
        $gidlist  = "0," . $mybb->settings['signaturecontrol_exemptgroups'] . ",";
        $groups = explode(",", $gidlist);
        $uid = $memprofile['uid'];


        $output_allow = "<br /><table border=\"0\" cellspacing=\"{$theme['borderwidth']}\" cellpadding=\"{$theme['tablespace']}\" class=\"tborder\"><tr><td class=\"thead\"><strong>{$lang->users_signature}</strong></td></tr><tr><td class=\"trow1\">{$memprofile['signature']}</td></tr></table>";
        $output_disallow = "</table>";

        if ($mybb->settings['signaturecontrol_onsetting'] == 1)
        {
            if (in_array($memprofile['usergroup'],$groups) == true) {
                $SignatureControlProfile = $output_allow;
                //echo "user is exempt";
            }
            else {
                if ($memprofile['postnum'] >= $mybb->settings['signaturecontrol_postcount'])
                {
                    $SignatureControlProfile = $output_allow;
                    //echo "user has required PC";
                }
                else {
                    $SignatureControlProfile = $output_disallow;
                    //echo "user needs more posts";
                }
            }
        }
        else {
            $SignatureControlProfile =  $output_allow;
        }
    }







?>